org.apache.hc.client5.http.impl.sync

## Class HttpRequestFutureTask<V>

- java.lang.Object
- - java.util.concurrent.FutureTask<V>
  - - org.apache.hc.client5.http.impl.sync.HttpRequestFutureTask<V>

Type Parameters:
  `V` -

All Implemented Interfaces:
  Runnable, Future<V>, RunnableFuture<V>

    public class HttpRequestFutureTask<V>
    extends FutureTask<V>

FutureTask implementation that wraps a HttpAsyncClientCallable and exposes various task specific metrics.

### Constructor Summary

Constructors
Constructor and Description
`HttpRequestFutureTask(org.apache.hc.core5.http.ClassicHttpRequest request, org.apache.hc.client5.http.impl.sync.HttpRequestTaskCallable<V> httpCallable)`

### Method Summary

Methods
`boolean` `cancel(boolean mayInterruptIfRunning)`
`long` `endedTime()`
`long` `requestDuration()`
`long` `scheduledTime()`
`long` `startedTime()`
`long` `taskDuration()`
`String` `toString()`

### Methods inherited from class java.util.concurrent.FutureTask

`done, get, get, isCancelled, isDone, run, runAndReset, set, setException`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Constructor Detail

#### HttpRequestFutureTask

    public HttpRequestFutureTask(org.apache.hc.core5.http.ClassicHttpRequest request,
                         org.apache.hc.client5.http.impl.sync.HttpRequestTaskCallable<V> httpCallable)

### Method Detail

#### cancel

    public boolean cancel(boolean mayInterruptIfRunning)

Specified by:
  `cancel` in interface `Future<V>`
Overrides:
  `cancel` in class `FutureTask<V>`

#### scheduledTime

    public long scheduledTime()

Returns:
  the time in millis the task was scheduled.

#### startedTime

    public long startedTime()

Returns:
  the time in millis the task was started.

#### endedTime

    public long endedTime()

Returns:
  the time in millis the task was finished/cancelled.

#### requestDuration

    public long requestDuration()

Returns:
  the time in millis it took to make the request (excluding the time it was scheduled to be executed).

#### taskDuration

    public long taskDuration()

Returns:
  the time in millis it took to execute the task from the moment it was scheduled.

#### toString

    public String toString()

Overrides:
  `toString` in class `Object`